
local AlarmHUDdps_startTime = nil
local AlarmHUDdps_endTime = nil
local AlarmHUDdps_dmgTotal = 0
local AlarmHUDdps_hitTotal = 0
local AlarmHUDdps_critTotal = 0
local AlarmHUDdps_missTotal = 0
local AlarmHUDdps_doReset = true

local AlarmHUDdps_hitBoss = 0
local AlarmHUDdps_missBoss = 0


function AlarmHUDdpsFrame_Reset()
  if AlarmHUDdps_doReset then
    AlarmHUDdps_startTime = nil
    AlarmHUDdps_endTime = nil
    AlarmHUDdps_dmgTotal = 0
    AlarmHUDdps_hitTotal = 0
    AlarmHUDdps_critTotal = 0
    AlarmHUDdps_missTotal = 0
    AlarmHUDdps_doReset = false
  end
end

local function AlarmHUDdpsFrame_ShortNumber(h)
  if h > 999999 then
    return format("%.1fm", h / 1000000)
  elseif h > 9999 then
    return format("%.1fk", h / 1000)
  else
    return format("%d", h)
  end
end


function AlarmHUDdpsFrame_OnEvent(frame, event, ...)
  local doUpdate = false

  if event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 ~= nil and bit.band(arg5, 0x00000001) == 0x00000001 then
    local boss = false

    --Anyone know how to get UnitClassification from GUID directly?
    if arg6 == UnitGUID("target") then
      boss = UnitClassification("target") == "worldboss"
    end

    if arg2 == "SPELL_DAMAGE" or arg2 == "SPELL_PERIODIC_DAMAGE" or arg2 == "RANGE_DAMAGE" then
      AlarmHUDdpsFrame_Reset()

      if AlarmHUDdps_startTime == nil then
        AlarmHUDdps_startTime = arg1
      end

      if arg18 == 1 then
        AlarmHUDdps_critTotal = AlarmHUDdps_critTotal + 1
      end

      AlarmHUDdps_dmgTotal = AlarmHUDdps_dmgTotal + arg12
      AlarmHUDdps_hitTotal = AlarmHUDdps_hitTotal + 1
      AlarmHUDdps_endTime = arg1

      if boss then
        AlarmHUDdps_hitBoss = AlarmHUDdps_hitBoss + 1
      end
    elseif arg2 == "SWING_DAMAGE" then
      AlarmHUDdpsFrame_Reset()

      if AlarmHUDdps_startTime == nil then
        AlarmHUDdps_startTime = arg1
      end

      if arg15 == 1 then
        AlarmHUDdps_critTotal = AlarmHUDdps_critTotal + 1
      end

      AlarmHUDdps_dmgTotal = AlarmHUDdps_dmgTotal + arg9
      AlarmHUDdps_hitTotal = AlarmHUDdps_hitTotal + 1
      AlarmHUDdps_endTime = arg1

      if boss then
        AlarmHUDdps_hitBoss = AlarmHUDdps_hitBoss + 1
      end
    elseif arg2 == "SPELL_MISSED" or arg2 == "SPELL_PERIODIC_MISS" or arg2 == "RANGE_MISS" or arg2 == "SWING_MISS" then
      AlarmHUDdpsFrame_Reset()

      if arg12 == "MISS" then
        AlarmHUDdps_missTotal = AlarmHUDdps_missTotal + 1

        if boss then
          AlarmHUDdps_missBoss = AlarmHUDdps_missOverall + 1
        end
      else
        AlarmHUDdps_hitTotal = AlarmHUDdps_hitTotal + 1

        if boss then
          AlarmHUDdps_hitBoss = AlarmHUDdps_hitBoss + 1
        end
      end
    end
    
    doUpdate = true
  elseif event == "PLAYER_REGEN_ENABLED" then
    AlarmHUDdps_doReset = true
  end

  if doUpdate and AlarmHUDdps_startTime ~= nil then
    local duration = max(AlarmHUDdps_endTime - AlarmHUDdps_startTime, 1)
    local dps = AlarmHUDdps_dmgTotal / duration
    local hitRate = (100 * AlarmHUDdps_hitTotal) / max((AlarmHUDdps_hitTotal + AlarmHUDdps_missTotal), 1)
    local critRate = (100 * AlarmHUDdps_critTotal) / max(AlarmHUDdps_hitTotal, 1)
    local bossHitRate = (100 * AlarmHUDdps_hitBoss) / max((AlarmHUDdps_hitBoss + AlarmHUDdps_missBoss), 1)

    AlarmHUDdpsFrameText:SetFormattedText("%s dmg / %d s = %d dps, %.2f%% hit, %.2f%% crit, %.2f%% boss hit", AlarmHUDdpsFrame_ShortNumber(AlarmHUDdps_dmgTotal), duration, dps, hitRate, critRate, bossHitRate)
    AlarmHUDdpsFrame:SetHeight(AlarmHUDdpsFrameText:GetStringHeight())
    AlarmHUDdpsFrame:SetWidth(AlarmHUDdpsFrameText:GetStringWidth())
  end
end


function AlarmHUDdpsFrame_OnLoad(frame)
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	frame:RegisterEvent("PLAYER_REGEN_ENABLED");
  frame:RegisterForDrag("LeftButton")

  AlarmHUDdpsFrameText:SetText("AlarmHUDdps Loaded")
  AlarmHUDdpsFrame:SetHeight(AlarmHUDdpsFrameText:GetStringHeight())
  AlarmHUDdpsFrame:SetWidth(AlarmHUDdpsFrameText:GetStringWidth())
  
  SLASH_ALARMHUDDPS1 = "/ahd"

  SlashCmdList["ALARMHUDDPS"] = function(arg)
    if arg == "resetboss" then
      AlarmHUDdps_hitBoss = 0
      AlarmHUDdps_missBoss = 0
      print("AlarmHUDdps: Boss hit data reset.")
    elseif arg == "report" then
      if InCombatLockdown() then
        print("AlarmHUDdps: Can not report during combat.")
      else
        if GetNumRaidMembers() > 0 then
          SendChatMessage(AlarmHUDdpsFrameText:GetText(), "RAID")
        elseif GetNumPartyMembers() > 0 then
          SendChatMessage(AlarmHUDdpsFrameText:GetText(), "PARTY")
        else
          print("AlarmHUDdps: " .. AlarmHUDdpsFrameText:GetText())
        end
      end
    else
      print("*** AlarmHUDdps Help ***")
      print("  /ahr report     -- Report current stats to raid or party.")
      print("  /ahr resetboss  -- Reset boss hit data.")
    end
  end
end
